//Version0.22

#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_image.h>

typedef enum {FALSE=0, TRUE} bool;

SDL_Surface *screenSurface;
SDL_Surface *iconSurface;
SDL_Surface *textSurface=NULL;
SDL_Rect dstTxt, srcTxt;
SDL_Rect dstRect, srcRect;
SDL_Event event;
TTF_Font *fontBold=NULL, *fontBoldBig=NULL;
SDL_Color color;
float difficulty = 0.0;
Sint8 riddle_size = 0;
Sint32 x_mouse=0, y_mouse=0;
Sint32 x_koord = 20, y_koord = 20;
Uint8 riddle_array[20][20];
Uint8 y_numbers[20][10], y_index;
Uint8 x_numbers[20][10], x_index;
Uint8 x_tile,y_tile;
Uint16 tileSize=20, constSize=20;
Uint16 numbSize=17;                                       // tileSize-3;
Uint16 x_riddleDist=210;                                  // 2*constSize+10*numbSize, 
Uint16 y_riddleDist=210;                                  // 2*constSize+10*numbSize;
bool done = FALSE;

#include "menu.c"          //includes mainmenu
#include "rid_functions.c" //includes countnumbers, create_riddle, changeTile and write_highscore
#include "riddle.c"        //includes riddle

int main (int argc, char *argv[])
{
  if (SDL_Init(SDL_INIT_VIDEO) == -1)
  {
    printf("Initialization of SDL failed: %s\n", SDL_GetError());
    exit(1);
  }
  atexit(SDL_Quit);
  screenSurface = SDL_SetVideoMode(650, 650, 24, SDL_HWSURFACE);
  if (screenSurface == NULL)
  {
    printf("I'm not able to set the video mode: %s\n", SDL_GetError());
    exit(1);
  }
  SDL_WM_SetCaption("Tileminator","");           // sets caption of window-title-bar
  iconSurface = SDL_LoadBMP("data/icon.bmp");    //set icon at title-bar
  SDL_WM_SetIcon(iconSurface, NULL);

  // Font Initialization
  color.r=255;
  color.g=255;
  color.b=255;
  TTF_Init();
  fontBold=TTF_OpenFont("data/FreeSansBold.ttf",12);
  fontBoldBig=TTF_OpenFont("data/FreeSansBold.ttf",42);
  //
  while(1)
  {
    mainmenu();		// show mainmenu and highscores, get choice for size and difficulty
    riddle ();		// create riddle, check input, make timer, make highscore
  }
  return 0;
}
