  // Counts the numbers which will be shown on top and on the left of the riddle
  // Stores the numbers in x_numbers[][] and y_numbers[][]
  // counts the correct tiles of the riddle and returns them
int countnumbers(){ 
  Uint8 Xnumber, Xnumber_index, Ynumber, Ynumber_index;
  Uint8 x_tile,y_tile;
  int tile_count=0;
  //Nummern berechnen und  in die Nummernfelder einsetzen
  for(y_tile=0; y_tile<=19 ;y_tile++){
    Xnumber=0;
    Xnumber_index=0;
    Ynumber=0;
    Ynumber_index=0;
    for(x_tile=0; x_tile<=19 ;x_tile++){
      if (riddle_array[y_tile][x_tile]=='X') {
        Xnumber++;					//ist ein Feld 'X', dann wird die Zählvariable erhöht
        }
      else {						//ist das Feld nicht 'X',
        if (Xnumber!=0){				//und wurde überhaupt gezählt
          x_numbers[y_tile][Xnumber_index]=Xnumber;	//so schreibe die Zählvariable in das Nummernfeld,
          Xnumber_index++;				//gehe in die nächste Spalte des Nummernfeldes
          Xnumber=0;					//und setzte die Zählvariable auf 0 zurück
        }
      }
    }
    for(x_tile=0; x_tile<=19 ;x_tile++){             //dasselbe für die Zeilen, wie für die Spalten...
      if (riddle_array[x_tile][y_tile]=='X') {
        Ynumber++;
      }
      else {
        if (Ynumber!=0){
          y_numbers[y_tile][Ynumber_index]=Ynumber;
          Ynumber_index++;
          Ynumber=0;
        }
      }
    }						//...bis hier
    if (Xnumber!=0){
      x_numbers[y_tile][Xnumber_index]=Xnumber;	//ist man am Ende einer Zeile bzw. Spalte, so wird der Zählwert, wenn !=0, geschrieben
    }
    if (Ynumber!=0){
      y_numbers[y_tile][Ynumber_index]=Ynumber;
    }
  }

  for(y_tile=0; y_tile<=(riddle_size-1) ;y_tile++){	//count the correct tiles to decrase later and to decide if game is won(tilecount==0)
    for(x_tile=0; x_tile<=(riddle_size-1) ;x_tile++){
      if (riddle_array[y_tile][x_tile]=='X')
        tile_count++;
    }
  }
  return tile_count;
} 



//Writes 'O's in the riddle array und zeros in the number arrays
void create_riddle(){
  Uint8 x_index, y_index;
  float x;
 //Initialize the riddle_array with 'O''s
  for(y_index=0; y_index<=19 ;y_index++){
    for(x_index=0; x_index<=19 ;x_index++){
      riddle_array[y_index][x_index]='O';
    }
  }
  //Felder mit den Nummern auf null setzen
  for (x_index=0; x_index<=19; x_index++){
    for (y_index=0; y_index<=9; y_index++){
      x_numbers[x_index][y_index]=0;
      y_numbers[x_index][y_index]=0;
    }
  }
  srand( (unsigned)time( NULL ) );
    for(y_index=0; y_index<=(riddle_size-1) ;y_index++){
      for(x_index=0; x_index<=(riddle_size-1) ;x_index++){
        x=(float) rand()/RAND_MAX;
        if (x<=difficulty)
        riddle_array[y_index][x_index]='X';
          else
        riddle_array[y_index][x_index]='O';
      }
    }
}



// function changeTile blits the tile from x-Coordinate xCoordTile to the screensurface
// changes the tilestatus in the riddle_array-matrix

void changeTile(Sint16 xCoordTile, char newState, SDL_Surface **tilesBitmap){
  srcRect.x=xCoordTile;
  riddle_array[y_mouse][x_mouse]=newState;    
  dstRect.x=x_riddleDist + (x_mouse)*(tileSize+1);
  dstRect.y=y_riddleDist + (y_mouse)*(tileSize+1);
  SDL_BlitSurface(*tilesBitmap, &srcRect, screenSurface, &dstRect);
}


void write_highscore(Uint16 min,Uint16 sec){
  int score = (60*min) +sec;
  int highscore = 0;
  Uint8 position;
  FILE *fpout;
  fpout = fopen("data/highscore", "r+");
  if (fpout != NULL) {
    switch (riddle_size){
      case 10: 
	if ((-0.01 < (difficulty-0.75)) && ((difficulty-0.75) < 0.01)) position=0;	// 5X5  stands in position 1 of he file
        else if ((-0.01 < (difficulty-0.6)) && ((difficulty-0.6) < 0.01))  position=1;	//10X10 stands in position 2
	else if ((-0.01 < (difficulty-0.4)) && ((difficulty-0.4) < 0.01))  position=2; //15X15 stands in position 3
        break;
      case 15: 
	if ((-0.01 < (difficulty-0.75)) && ((difficulty-0.75) < 0.01)) position=3;	// 5X5  stands in position 1 of the file
        else if ((-0.01 < (difficulty-0.65)) && ((difficulty-0.65) < 0.01)) position=4;	//10X10 stands in position 2
	else if ((-0.01 < (difficulty-0.55)) && ((difficulty-0.55) < 0.01)) position=5; //15X15 stands in position 3
        break;
      case 20: 
	if ((-0.01 < (difficulty-0.8)) && ((difficulty-0.8) < 0.01))  position=6;	// 5X5  stands in position 1 of the file
        else if ((-0.01 < (difficulty-0.7)) && ((difficulty-0.7) < 0.01))  position=7;	//10X10 stands in position 2
        else if ((-0.01 < (difficulty-0.625)) && ((difficulty-0.625) < 0.01))  position=8; //15X15 stands in position 3
	break;
    }
      fseek (fpout, position*5, SEEK_SET);
      fscanf(fpout, ",%4d" ,&highscore);
    if (highscore>= score)
	{ 
	fseek (fpout, position*5, SEEK_SET);
	fprintf(fpout, ",%4d",score);
	}
    fclose(fpout);
  }
  else 
  printf("Can't open Highscorefile");
} 
