    // calls create_riddle and countnumbers
    // blits pictures and numbers
    // creates timer, handles input

void riddle ()
{
  SDL_Surface *backgroundBitmap, *livesBitmap, *tilesBitmap, *gridBitmap, *vNumbersBitmap, *hNumbersBitmap,*hudBitmap, *gameoverBitmap;
  
  SDL_Rect srcGrid, dstGrid;
  SDL_Rect srcHUD, dstHUD; 
  SDL_Rect srcLiv, dstLiv;

  //Sint8 x_mouse, y_mouse;
  Uint32 gridsize=0;
  Uint8 mouse_button;
  
  char numberString[2];
  char timer_text[6];

  Sint8 lives=3,temp_lives=0;
  Uint16  tile_count=0;
  Uint32 timer=0, timer_start=0, timer_temp=0;
  Uint16 min=0,sek=0;
  char sek_text[3], min_text[3];
  
  create_riddle ();             // set riddle and number arrays to zero then create a riddle
  tile_count = countnumbers ();	// count correct tiles in row, column and in general
  
  //--------------> Load Bitmaps
  
  tilesBitmap = IMG_Load("data/tiles.gif");      
  backgroundBitmap = IMG_Load("data/background.jpg");
  gridBitmap = IMG_Load("data/chess.gif");
  hNumbersBitmap = IMG_Load("data/hnumbers.gif");
  vNumbersBitmap = IMG_Load("data/vnumbers.gif");
  hudBitmap = IMG_Load("data/hud.gif");
  livesBitmap = IMG_Load("data/smiley.gif");
  gameoverBitmap = IMG_Load("data/gameover.gif");
  
  if (tilesBitmap == NULL){printf("%s\n", SDL_GetError());exit(1);}
  if (backgroundBitmap == NULL){printf("%s\n", SDL_GetError());exit(1);}
  if (gridBitmap == NULL){printf("%s\n", SDL_GetError());exit(1);}
  if (hNumbersBitmap == NULL){printf("%s\n", SDL_GetError());exit(1);}
  if (vNumbersBitmap == NULL){printf("%s\n", SDL_GetError());exit(1);}
  if (hudBitmap == NULL){printf("%s\n", SDL_GetError());exit(1);}
  if (livesBitmap == NULL){printf("%s\n", SDL_GetError());exit(1);}
  if (gameoverBitmap == NULL){printf("%s\n", SDL_GetError());exit(1);}
  
  SDL_SetColorKey(tilesBitmap, SDL_SRCCOLORKEY, SDL_MapRGB(tilesBitmap->format, 255, 0, 255));       // set pink to transparent at tilesBitmap,
  SDL_SetColorKey(hNumbersBitmap, SDL_SRCCOLORKEY, SDL_MapRGB(hNumbersBitmap->format, 255, 0, 255)); // hNumbersBitmap,
  SDL_SetColorKey(vNumbersBitmap, SDL_SRCCOLORKEY, SDL_MapRGB(vNumbersBitmap->format, 255, 0, 255)); // vNumbersBitmap,
  SDL_SetColorKey(hudBitmap, SDL_SRCCOLORKEY, SDL_MapRGB(hudBitmap->format, 255, 0, 255));           // hudBitmap,
  SDL_SetColorKey(livesBitmap, SDL_SRCCOLORKEY, SDL_MapRGB(livesBitmap->format, 255, 0, 255));       // livesBitmap and
  SDL_SetColorKey(gameoverBitmap, SDL_SRCCOLORKEY, SDL_MapRGB(gameoverBitmap->format, 255, 0, 255)); // gameoverBitmap
  
  
  //-------------> Blit Bitmaps
  
  gridsize =(riddle_size/5)*105;  
  
  dstRect.x = 0;			//Blit backgroundimage
  dstRect.y = 0;
  dstRect.w = 650;
  dstRect.h = 650;
  SDL_BlitSurface(backgroundBitmap, NULL, screenSurface, &dstRect);
  
  srcRect.x = 0;
  srcRect.y = 0;
  
  srcRect.h = gridsize+1; 		//Blit grid
  srcRect.w = gridsize+1;
  dstRect.w = gridsize+1; 
  dstRect.h = gridsize+1;
  dstRect.x = x_riddleDist-1;
  dstRect.y = y_riddleDist-1;
  SDL_BlitSurface(gridBitmap, &srcRect, screenSurface, &dstRect);
  
  srcRect.h = numbSize*10;		//Blit background of vertical number
  srcRect.w = gridsize;
  dstRect.w = gridsize; 
  dstRect.h = numbSize*10;
  dstRect.x = x_riddleDist;
  dstRect.y = constSize;
  SDL_BlitSurface(vNumbersBitmap, &srcRect, screenSurface, &dstRect);
  
  srcRect.h = gridsize;                  //Blit background of horizontal number
  srcRect.w = numbSize*10;
  dstRect.w = numbSize*10;
  dstRect.h = gridsize;
  dstRect.x = constSize;
  dstRect.y = y_riddleDist;
  SDL_BlitSurface(hNumbersBitmap, &srcRect, screenSurface, &dstRect);
  
  srcRect.h = 170;	         	//Blit HUD
  srcRect.w = 170;
  dstRect.w = 170;
  dstRect.h = 170;
  dstRect.x = constSize;
  dstRect.y = constSize;
  SDL_BlitSurface(hudBitmap, &srcRect, screenSurface, &dstRect);
  
  dstRect.w = tileSize; 		//Blit the Riddle
  dstRect.h = tileSize;
  srcRect.w = tileSize;
  srcRect.h = tileSize;
  for(y_tile=0; y_tile<=riddle_size-1 ;y_tile++)
    {
      for(x_tile=0; x_tile<=riddle_size-1 ;x_tile++)
	{
	  dstRect.y = y_riddleDist + y_tile * (tileSize+1);
	  dstRect.x = x_riddleDist + x_tile * (tileSize+1);
	  SDL_BlitSurface(tilesBitmap, &srcRect, screenSurface, &dstRect);
	}
    }
  for (x_index=0; x_index<=riddle_size-1; x_index++)   //Blit vertical numbers
    {	                       
      for (y_index=0; y_index<=9; y_index++)
	{
	  if (y_numbers[x_index][y_index]==0 && y_index==0)
	    {
	      sprintf(numberString, "%d", y_numbers[x_index][y_index]);
	      textSurface=TTF_RenderText_Blended(fontBold,numberString,color);
	      srcTxt.x=srcTxt.y=0;
	      srcTxt.h=textSurface->h;
	      srcTxt.w=textSurface->w;
	      dstTxt=srcTxt;
	      dstTxt.x=x_riddleDist+7+x_index*(tileSize+1);
	      dstTxt.y=constSize+y_index*(tileSize-3)+1; 
	      SDL_BlitSurface(textSurface,&srcTxt,screenSurface,&dstTxt);
	      y_index=10;
	    }
	  else
	    {
	      if (y_numbers[x_index][y_index]!=0)
		{
		  sprintf(numberString, "%d", y_numbers[x_index][y_index]);
		  textSurface=TTF_RenderText_Blended(fontBold,numberString,color);
		  srcTxt.x=srcTxt.y=0;
		  srcTxt.h=textSurface->h;
		  srcTxt.w=textSurface->w;
		  dstTxt=srcTxt;
		  dstTxt.x=x_riddleDist+7+x_index*(tileSize+1);
		  dstTxt.y=constSize+y_index*(tileSize-3)+1; 
		  SDL_BlitSurface(textSurface,&srcTxt,screenSurface,&dstTxt);
		}
	    }
	}
    }

  for (x_index=0; x_index<=riddle_size-1; x_index++)   //Blit horizontal numbers
  {	                        
    for (y_index=0; y_index<=9; y_index++)
      {
	if (x_numbers[x_index][y_index]==0 && y_index==0)
	  {
	    sprintf(numberString, "%d", x_numbers[x_index][y_index]);
	    textSurface=TTF_RenderText_Blended(fontBold,numberString,color);
	    srcTxt.x=srcTxt.y=0;
	    srcTxt.h=textSurface->h;
	    srcTxt.w=textSurface->w;
	    dstTxt=srcTxt;
	    dstTxt.x=26+y_index*(tileSize-3);
	    dstTxt.y=1+y_riddleDist+(x_index*(tileSize+1)); 
	    SDL_BlitSurface(textSurface,&srcTxt,screenSurface,&dstTxt);
	    y_index=10;
	  }
	else 
	  {
	    if (x_numbers[x_index][y_index]!=0)
	      {
		sprintf(numberString, "%d", x_numbers[x_index][y_index]);
		textSurface=TTF_RenderText_Blended(fontBold,numberString,color);
		srcTxt.x=srcTxt.y=0;
		srcTxt.h=textSurface->h;
		srcTxt.w=textSurface->w;
		dstTxt=srcTxt;
		dstTxt.x=26+y_index*(tileSize-3);
		//y_riddleDist=2*constSize+10*numbSize;		//sonst zickt er
		dstTxt.y=1+y_riddleDist+(x_index*(tileSize+1)); 
		SDL_BlitSurface(textSurface,&srcTxt,screenSurface,&dstTxt);
	      }
	  }
      }
  }

  SDL_Flip(screenSurface);
  

  srcTxt.x=srcTxt.y=0;                    //set position and size of timer numbers
  dstTxt.w=200;
  dstTxt.h=50;
  srcTxt.w=200;
  srcTxt.h=50;
  dstTxt.x=50;
  dstTxt.y=30;
  
  timer_start = SDL_GetTicks();           //     timer initialisieren
  timer_temp = (SDL_GetTicks() - timer_start)/1000;
  timer = timer_temp;
  
  do 
    {
      while (SDL_PollEvent(&event) && (tile_count!=0)) 
	{

	  if(event.key.keysym.sym==SDLK_ESCAPE) {done=TRUE;}
	  switch(event.type) 
	    {
	    case SDL_QUIT: exit(1); break;
	    case SDL_MOUSEBUTTONDOWN: 
	      mouse_button=event.button.button;
	      x_mouse=(event.button.x-x_riddleDist)/(tileSize+1);
	      y_mouse=(event.button.y-y_riddleDist)/(tileSize+1); 

	      break;
	      
	    default: break;
	    }

	}
    	
   
  //check if mouseclick was in the riddlearea
  if ((x_mouse>=0) && (x_mouse<=riddle_size-1) && (y_mouse>=0) && (y_mouse<=riddle_size-1))
    {
      
      // check if left mousebutton was pushed; 
      // check status of clicked tile and change tile and tile_count or lives
      if (mouse_button==SDL_BUTTON_LEFT)
	{
	  if ((riddle_array[y_mouse][x_mouse]=='X') || (riddle_array[y_mouse][x_mouse]=='R'))
	    {
	      changeTile(20,'S',&tilesBitmap);                              //Status is 'S'olved because right tile was clicked
	      tile_count--;
	    }
	  if((riddle_array[y_mouse][x_mouse]=='O') || (riddle_array[y_mouse][x_mouse]=='W'))
	    {
	      changeTile(40,'F',&tilesBitmap);                              //Status is 'F'ailed because wrong tile was clicked
	      lives--;
	    }
	}
      
      
      // check if right mousebutton was pushed; 
      // check status of clicked tile and change tile
      if (mouse_button==SDL_BUTTON_RIGHT)
	{
	  switch(riddle_array[y_mouse][x_mouse]){
	  case 'R':
	    changeTile(0, 'X',&tilesBitmap);                                // 'X' == was 'R'ight marked before, is changed back to unmarked (right) now
	    break;
	  case 'W':  
	    changeTile(0, 'O',&tilesBitmap);                                // 'O' == was 'W'rong marged before, is changed to unmarked (wrong) now
	    break;
	  case 'X':
	    changeTile(60, 'R',&tilesBitmap);                               // 'R' Right Marked
	    break;
	  case 'O':
	    changeTile(60, 'W',&tilesBitmap);                               // 'W' Wrong Marked
	    break;
	  default: break;
	  }
	}
    }
  mouse_button=0;                   //reset mouse_button, otherwise marked tile would disappear, displayed, disapper...


  timer_temp = (SDL_GetTicks() - timer_start)/1000;
  if (timer_temp > timer)           
    {
      timer = timer_temp;
      srcHUD.x = srcHUD.y =0; 	    // blit HUD to overpaint old time
      srcHUD.h = 170;
      srcHUD.w = 170;
      dstHUD.w = 170;
      dstHUD.h = 170;
      dstHUD.x = constSize;
      dstHUD.y = constSize;
      SDL_BlitSurface(hudBitmap, &srcHUD, screenSurface, &dstHUD);

      min = timer / 60;             // blit timer
      sek = timer % 60;
      sprintf(sek_text, "%d", sek);
      sprintf(min_text, "%d", min);
      strcpy(timer_text,"");
      strcat(timer_text,min_text);
      strcat(timer_text,":");
      if (sek<10) strcat(timer_text,"0");
      strcat(timer_text,sek_text);
      textSurface=TTF_RenderText_Blended(fontBoldBig,timer_text,color);
      SDL_BlitSurface(textSurface,&srcTxt, screenSurface,&dstTxt);
    }
  
  dstLiv.x=30;                      //Blit Livesmileys
  dstLiv.y=90;
  dstLiv.w=dstLiv.h=50;
  srcLiv.y=0;
  srcLiv.x=50;
  srcLiv.w=srcLiv.h=50;
  for (temp_lives=lives; temp_lives>0;temp_lives--)
    {                                                 
      SDL_BlitSurface(livesBitmap, &srcLiv, screenSurface, &dstLiv);
      dstLiv.x+=50;
    }
  srcLiv.x=0;
  for (temp_lives=3-lives; temp_lives>0; temp_lives--)
    {
      SDL_BlitSurface(livesBitmap, &srcLiv, screenSurface, &dstLiv);
      dstLiv.x+=50;
    }
  
  if (lives == 0)         // all lives are lost -> LOST -> game over
    {
      done=TRUE;
      srcRect.x=0;
      srcRect.y=75;
      srcRect.w=dstRect.w=150;
      srcRect.h=dstRect.h=75;
      dstRect.x=30;
      dstRect.y=110;
      SDL_BlitSurface(gameoverBitmap, &srcRect, screenSurface, &dstRect);
      dstRect.w = tileSize; 		//Reveal all correct/wrong tiles
      dstRect.h = tileSize;
      srcRect.y=0;
      srcRect.w = tileSize;
      srcRect.h = tileSize;
      for(y_tile=0; y_tile<=riddle_size-1 ;y_tile++)
	{
	  for(x_tile=0; x_tile<=riddle_size-1 ;x_tile++)
	    {
	      dstRect.y = y_riddleDist + y_tile * (tileSize+1);
	      dstRect.x = x_riddleDist + x_tile * (tileSize+1);
	      if ((riddle_array[y_tile][x_tile]=='X') || (riddle_array[y_tile][x_tile]=='R') || (riddle_array[y_tile][x_tile]=='S'))
		srcRect.x=20;
	      else
		srcRect.x=40;
	      SDL_BlitSurface(tilesBitmap, &srcRect, screenSurface, &dstRect);
	    }
	}
      SDL_Flip(screenSurface);

      while (SDL_PollEvent(&event) || event.type!=SDL_MOUSEBUTTONDOWN)
	{
	  if (event.type == SDL_QUIT)
	    exit(1);
	  SDL_Delay(5);
	}
    }

  if (tile_count==0)         // all correct tiles were discovered -> WON -> game over
    {
      done=TRUE;
      write_highscore(min, sek);
      srcRect.x=0, srcRect.y=0;
      srcRect.w=dstRect.w=150;
      srcRect.h=dstRect.h=75;
      dstRect.x=30;
      dstRect.y=110;
      SDL_BlitSurface(gameoverBitmap, &srcRect, screenSurface, &dstRect);
      SDL_Flip(screenSurface);

      while (SDL_PollEvent(&event) || event.type!=SDL_MOUSEBUTTONDOWN)
	{
	  if (event.type == SDL_QUIT)
	    exit(1);
	  SDL_Delay(5);
	}
    }
  
  SDL_Flip(screenSurface);
  SDL_Delay(60);                  //lowers CPU usage a little bit
    }
  while (!done);

  SDL_FreeSurface(tilesBitmap);
  SDL_FreeSurface(gridBitmap);
  SDL_FreeSurface(vNumbersBitmap);
  SDL_FreeSurface(hNumbersBitmap);
  SDL_FreeSurface(backgroundBitmap);
  SDL_FreeSurface(hudBitmap);
  SDL_FreeSurface(livesBitmap);
  SDL_FreeSurface(gameoverBitmap);
}
